/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "taviamdifrm.h"
#include "taviapartsview.h"
#include <kxmlguifactory.h>
#include <kmainwindow.h>
#include <kaction.h>
#include <qcursor.h>
#include <qptrlist.h>
#include <taviatabbuttonconfigwidget.h>
#include <qvbox.h>
#include <taviatabbox.h>

TaviaMdiFrm::TaviaMdiFrm(QWidget *parent, const char *name, KMdi::MdiMode mdiMode, WFlags flags)
 : KMdiMainFrm(parent, name, mdiMode, flags)
{
    //setDefaultChildFrmSize(QSize(400,400));
    hideViewTaskBar();
    //setFrameDecorOfAttachedViews(KMdi::Win95Look);
/*    TaviaPartsView *h = new TaviaPartsView();
    KMdiChildView *v = createWrapper(h,"parts",0);
    addWindow(v);
    h->openURL(KURL("http://nop.net-p.org/"),KParts::URLArgs());
*/    //h = new TaviaPartsView();
    //addWindow(createWrapper(h,"parts",0));
    //h->openURL(KURL("http://nop.net-p.org/"),KParts::URLArgs());
    //h = new TaviaPartsView();
    //addWindow(createWrapper(h,"parts",0));
    //h->openURL(KURL("http://nop.net-p.org/"),KParts::URLArgs());
    //addWindow(createWrapper(h,"parts",0));
    //h->openURL(KURL("/home/tamra/"),KParts::URLArgs());windowMenu
    //h = new TaviaPartsView();
    //addWindow(createWrapper(h,"parts",0));
    //h->openURL(KURL("/home/tamra/"),KParts::URLArgs());
    //TaviaTabBox *t = new TaviaTabBox(this);
    //addWindow(createWrapper(t,"Button",0));
//    v->mdiParent()->resize(400,400);
    new KAction(i18n("MDI Menu"),"window_new",ALT + Key_M,this,SLOT(mdiMenuPopup()),actionCollection(),"mdiMenu");
    new KAction(i18n("ButtonColor Setting"),"",0,this,SLOT(bcConfig()),actionCollection(),"buttonColorSetting");
    connect(this,SIGNAL(mdiModeHasBeenChangedTo(KMdi::MdiMode)),this,SLOT(changeMdiMode(KMdi::MdiMode )));
}


TaviaMdiFrm::~TaviaMdiFrm()
{
}






/*!
    \fn TaviaMdiFrm::closeWindow(KMdiChildView *pWnd, bool layoutTaskBar=true)
 */
void TaviaMdiFrm::closeWindow(KMdiChildView *pWnd, bool layoutTaskBar)
{
    kdDebug() << "windowClose..." << endl;
    KMdiMainFrm::closeWindow(pWnd,layoutTaskBar);
}


/*!
    \fn TaviaMdiFrm::mdiMenuPopup()
 */
void TaviaMdiFrm::mdiMenuPopup()
{
    hideViewTaskBar();
    windowMenu()->popup(QCursor::pos());
}



/*!
    \fn TaviaMdiFrm::changeMdiMode(KMdi::MdiMode m)
 */
void TaviaMdiFrm::changeMdiMode(KMdi::MdiMode m)
{
    if (m == KMdi::ChildframeMode) hideViewTaskBar();
}


/*!
    \fn TaviaMdiFrm::bcConfig()
 */
void TaviaMdiFrm::bcConfig()
{
    pBcd = new KDialogBase(this, "buttonColorSetting", true,i18n("ButtonColor Setting"),
        KDialogBase::Ok|KDialogBase::Cancel, KDialogBase::Ok, true);
    QVBox *vb = new QVBox(pBcd);
    TaviaTabButtonConfigWidget *pBcw = new TaviaTabButtonConfigWidget(0,vb);
    pBcd->setMainWidget(vb);
    pBcd->show();
    
    //debug
    connect(pBcw,SIGNAL(destroyed()),this,SLOT(destroyBcd()));

    if (pBcd->exec() == KDialog::Accepted) {
        pBcw->applySetting();
        emit signalUpdate();
    }
    delete(pBcd);
}


/*!
    \fn TaviaMdiFrm::destroyBcd()
 */
void TaviaMdiFrm::destroyBcd()
{
    kdDebug() << "dialog delete." << endl;
}
