/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIATABBOX_H
#define TAVIATABBOX_H

#include <qlabel.h>
#include <qscrollview.h>
#include <qptrlist.h>
#include <taviatabbutton.h>
#include <taviatabboxframe.h>
#include <taviatabbuttonseparator.h>

/**
@author TAM(Teppei Tamra)
*/
class TaviaTabBoxFrame;
class TaviaTabButton;
class TaviaTabButtonSeparator;

class TaviaTabBox : public QScrollView
{
Q_OBJECT
public:
    friend class TaviaTabBoxFrame;
    TaviaTabBox(QWidget * parent = 0, const char * name = 0, WFlags f = 0);

    ~TaviaTabBox();
    TaviaTabButton * addButton();
    void delButton(TaviaTabButton *b);
    void wheelAction(QWheelEvent * e);
    void updateBox();

protected:
    QPtrList<TaviaTabButton> buttons;
    QPtrList<TaviaTabButtonSeparator> seps;
    unsigned int size;
    bool vertical;
public slots:
    void downScroll();
    void upScroll();
protected:
    virtual void contentsWheelEvent(QWheelEvent * e);
signals:
    void extWheelActionUp();
    void extWheelActionDown();
protected slots:
    void buttonDropedInSeparator(TaviaTabButtonSeparator *s,TaviaTabButton *b);
    void slotUpdate();
};

#endif
