/***************************************************************************
 *   Copyright (C) 2004 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIATABBUTTONCONFIG_H
#define TAVIATABBUTTONCONFIG_H

#include <qstring.h>
#include <qcolor.h>
#include <taviatabbuttonconfigwidget.h>

/**
@author TAM(Teppei Tamra)
*/
class TaviaTabButtonConfig;
class TaviaTabButtonConfigWidget;
class TaviaTabButtonConfig{
public:
    friend class TaviaTabButtonConfigWidget;
    
    TaviaTabButtonConfig(const QString &configGroup = "default");

    ~TaviaTabButtonConfig();
    QColor bgColor();
    QColor fgColor();
    QColor activeColor();
    QColor selectedColor();
    unsigned int edgeR();
    unsigned int grad();
    bool roundEdge();
    static TaviaTabButtonConfig *getDefault();

protected:
    void saveConfig(const QString &key = "");

protected:
    QColor _bgColor;
    QColor _fgColor;
    QColor _activeColor;
    QColor _selectedColor;
    unsigned int _edgeR;
    unsigned int _grad;
    bool _roundEdge;
    QString _configGroup;
    static TaviaTabButtonConfig *defaultColor;

};

#endif
