/***************************************************************************
 *   Copyright (C) 2004 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "taviatabbuttonconfigwidget.h"
#include <qvbox.h>
#include <qlabel.h>
#include <kdebug.h>

TaviaTabButtonConfigWidget::TaviaTabButtonConfigWidget(TaviaTabButtonConfig *config, QWidget *parent, const char *name)
 : QWidget(parent, name)
{
    if (!config) config = TaviaTabButtonConfig::getDefault();
    initWidget(config);
}

TaviaTabButtonConfigWidget::~TaviaTabButtonConfigWidget()
{
}



/*!
    \fn TaviaTabButtonConfigWidget::initWidget(TaviaTabButtonConfig *config)
 */
void TaviaTabButtonConfigWidget::initWidget(TaviaTabButtonConfig *config)
{
    pConfig = config;
    
    QHBoxLayout *hb = new QHBoxLayout(this);
    
    QVBox *vb1 = new QVBox(this);
    new QLabel(i18n("FG/BG Color:"),vb1);
    pDcb = new KDualColorButton(config->fgColor(),config->bgColor(),vb1);
    pDcb->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
    
    QVBox *vb2 = new QVBox(this);
    new QLabel(i18n("Active Color:"),vb2);
    pAcb = new KColorButton(config->activeColor(),config->activeColor(),vb2);
    pAcb->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);

    //QVBox *vb3 = new QVBox(this);
    new QLabel(i18n("Selected Color:"),vb2);
    pScb = new KColorButton(config->selectedColor(),config->selectedColor(),vb2);
    pScb->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);

    hb->addWidget(vb1);
    hb->addWidget(vb2);

}




/*!
    \fn TaviaTabButtonConfigWidget::resetSetting()
 */
void TaviaTabButtonConfigWidget::resetSetting()
{
    pDcb->setForeground(pConfig->fgColor());
    pDcb->setBackground(pConfig->bgColor());
    pAcb->setColor(pConfig->activeColor());
    pScb->setColor(pConfig->selectedColor());
}


/*!
    \fn TaviaTabButtonConfigWidget::applySetting()
 */
void TaviaTabButtonConfigWidget::applySetting()
{
    pConfig->_fgColor = pDcb->foreground();
    pConfig->_bgColor = pDcb->background();
    pConfig->_activeColor = pAcb->color();
    pConfig->_selectedColor = pScb->color();
    pConfig->saveConfig();
    kdDebug() << "applySetting" << endl;
    emit applied();
}
