/***************************************************************************
 *   Copyright (C) 2004 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIATABBUTTONSEPARATOR_H
#define TAVIATABBUTTONSEPARATOR_H

#include <qwidget.h>
#include <taviatabbuttonconfig.h>
#include <taviatabbox.h>

/**
@author TAM(Teppei Tamra)
*/
class TaviaTabButton;
class TaviaTabButtonConfig;
class TaviaTabBox;

class TaviaTabButtonSeparator : public QWidget
{
Q_OBJECT
public:
    TaviaTabButtonSeparator(TaviaTabBox *parent = 0, const char *name = 0);

    ~TaviaTabButtonSeparator();
    unsigned int getSize();
    void setSize(unsigned int s);
    void update();

protected:
    TaviaTabBox *tabbox;
    TaviaTabButtonConfig *config;
    unsigned int size;
protected:
    virtual void dragEnterEvent(QDragEnterEvent *e);
    virtual void dropEvent(QDropEvent *e);
    virtual void dragLeaveEvent(QDragLeaveEvent *e);
    
signals:
    void buttonDroped(TaviaTabButtonSeparator *s,TaviaTabButton *b);
};

#endif
